package vbmundo.rotaryclock;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "vbmundo.rotaryclock", "vbmundo.rotaryclock.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "vbmundo.rotaryclock", "vbmundo.rotaryclock.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "vbmundo.rotaryclock.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        Object[] o;
        if (permissions.length > 0)
            o = new Object[] {permissions[0], grantResults[0] == 0};
        else
            o = new Object[] {"", false};
        processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public flm.b4a.bitmapplus.BitmapPlus _bp = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmppressed = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _ivbgknob = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _ivrotatknob = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spmode = null;
public static int _minangle = 0;
public static int _maxangle = 0;
public static int _switchsectorangle = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lblhora = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblminutos = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbldospuntos = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbltitle = null;
public static double _angle = 0;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
anywheresoftware.b4a.agraham.reflection.Reflection _r = null;
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="bmp = LoadBitmap(File.DirAssets, \"rotatknob.png\")";
mostCurrent._bmp = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"rotatknob.png");
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="bmpPressed = LoadBitmap(File.DirAssets, \"rotatkno";
mostCurrent._bmppressed = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"rotatknob_pressed.png");
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="ivRotatKnob.Initialize(\"\")";
mostCurrent._ivrotatknob.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="ivRotatKnob.Gravity = Gravity.NO_GRAVITY";
mostCurrent._ivrotatknob.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.NO_GRAVITY);
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="Activity.AddView(ivRotatKnob, 60dip, 30dip, bmp.W";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._ivrotatknob.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)),(int) (mostCurrent._bmp.getWidth()*anywheresoftware.b4a.keywords.Common.Density),(int) (mostCurrent._bmp.getHeight()*anywheresoftware.b4a.keywords.Common.Density));
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="Dim r As Reflector";
_r = new anywheresoftware.b4a.agraham.reflection.Reflection();
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="r.Target = ivRotatKnob";
_r.Target = (Object)(mostCurrent._ivrotatknob.getObject());
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="r.SetOnTouchListener(\"Knob_Touch\")";
_r.SetOnTouchListener(processBA,"Knob_Touch");
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="Angle = MinAngle";
_angle = _minangle;
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="ivRotatKnob.SetBackgroundImage(bp.Rotate(bmp, bmp";
mostCurrent._ivrotatknob.SetBackgroundImage(mostCurrent._bp.Rotate((android.graphics.Bitmap)(mostCurrent._bmp.getObject()),mostCurrent._bmp.getWidth(),mostCurrent._bmp.getHeight(),(int) (_angle),anywheresoftware.b4a.keywords.Common.True));
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="LblHora.Initialize(\"LblHora\")";
mostCurrent._lblhora.Initialize(mostCurrent.activityBA,"LblHora");
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="Activity.AddView(LblHora,ivRotatKnob.Left+30di";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lblhora.getObject()),(int) (mostCurrent._ivrotatknob.getLeft()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30))),(int) (mostCurrent._ivrotatknob.getTop()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (65)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (70)));
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="LblHora.Text=DateTime.GetHour(DateTime.Now)";
mostCurrent._lblhora.setText((Object)(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(anywheresoftware.b4a.keywords.Common.DateTime.getNow())));
RDebugUtils.currentLine=131093;
 //BA.debugLineNum = 131093;BA.debugLine="LblHora.TextColor=Colors.White";
mostCurrent._lblhora.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
RDebugUtils.currentLine=131094;
 //BA.debugLineNum = 131094;BA.debugLine="LblHora.TextSize=50";
mostCurrent._lblhora.setTextSize((float) (50));
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="LblHora.Typeface=Typeface.DEFAULT_BOLD";
mostCurrent._lblhora.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="LblHora.Color=Colors.Transparent";
mostCurrent._lblhora.setColor(anywheresoftware.b4a.keywords.Common.Colors.Transparent);
RDebugUtils.currentLine=131098;
 //BA.debugLineNum = 131098;BA.debugLine="LblDosPuntos.Initialize(\"LblDosPuntos\")";
mostCurrent._lbldospuntos.Initialize(mostCurrent.activityBA,"LblDosPuntos");
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="Activity.AddView(LblDosPuntos,LblHora.Left+Lbl";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lbldospuntos.getObject()),(int) (mostCurrent._lblhora.getLeft()+mostCurrent._lblhora.getWidth()),(int) (mostCurrent._ivrotatknob.getTop()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (70)));
RDebugUtils.currentLine=131100;
 //BA.debugLineNum = 131100;BA.debugLine="LblDosPuntos.Text=\":\"";
mostCurrent._lbldospuntos.setText((Object)(":"));
RDebugUtils.currentLine=131101;
 //BA.debugLineNum = 131101;BA.debugLine="LblDosPuntos.TextColor=Colors.White";
mostCurrent._lbldospuntos.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="LblDosPuntos.TextSize=50";
mostCurrent._lbldospuntos.setTextSize((float) (50));
RDebugUtils.currentLine=131103;
 //BA.debugLineNum = 131103;BA.debugLine="LblDosPuntos.Typeface=Typeface.DEFAULT_BOLD";
mostCurrent._lbldospuntos.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
RDebugUtils.currentLine=131104;
 //BA.debugLineNum = 131104;BA.debugLine="LblDosPuntos.Color=Colors.Transparent";
mostCurrent._lbldospuntos.setColor(anywheresoftware.b4a.keywords.Common.Colors.Transparent);
RDebugUtils.currentLine=131105;
 //BA.debugLineNum = 131105;BA.debugLine="LblDosPuntos.Gravity=Gravity.CENTER_HORIZONTAL";
mostCurrent._lbldospuntos.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL);
RDebugUtils.currentLine=131107;
 //BA.debugLineNum = 131107;BA.debugLine="LblMinutos.Initialize(\"LblMinutos\")";
mostCurrent._lblminutos.Initialize(mostCurrent.activityBA,"LblMinutos");
RDebugUtils.currentLine=131108;
 //BA.debugLineNum = 131108;BA.debugLine="Activity.AddView(LblMinutos,LblDosPuntos.Left+";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lblminutos.getObject()),(int) (mostCurrent._lbldospuntos.getLeft()+mostCurrent._lbldospuntos.getWidth()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2))),(int) (mostCurrent._ivrotatknob.getTop()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (65)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (70)));
RDebugUtils.currentLine=131109;
 //BA.debugLineNum = 131109;BA.debugLine="LblMinutos.Text=DateTime.GetMinute(DateTime.Now)";
mostCurrent._lblminutos.setText((Object)(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(anywheresoftware.b4a.keywords.Common.DateTime.getNow())));
RDebugUtils.currentLine=131110;
 //BA.debugLineNum = 131110;BA.debugLine="LblMinutos.TextColor=Colors.White";
mostCurrent._lblminutos.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
RDebugUtils.currentLine=131111;
 //BA.debugLineNum = 131111;BA.debugLine="LblMinutos.TextSize=50";
mostCurrent._lblminutos.setTextSize((float) (50));
RDebugUtils.currentLine=131112;
 //BA.debugLineNum = 131112;BA.debugLine="LblMinutos.Typeface=Typeface.DEFAULT_BOLD";
mostCurrent._lblminutos.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
RDebugUtils.currentLine=131113;
 //BA.debugLineNum = 131113;BA.debugLine="LblMinutos.Color=Colors.Transparent";
mostCurrent._lblminutos.setColor(anywheresoftware.b4a.keywords.Common.Colors.Transparent);
RDebugUtils.currentLine=131115;
 //BA.debugLineNum = 131115;BA.debugLine="LblTitle.initialize(\"LblTitle\")";
mostCurrent._lbltitle.Initialize(mostCurrent.activityBA,"LblTitle");
RDebugUtils.currentLine=131116;
 //BA.debugLineNum = 131116;BA.debugLine="Activity.AddView(LblTitle,Gravity.CENTER,2dip,300";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lbltitle.getObject()),anywheresoftware.b4a.keywords.Common.Gravity.CENTER,anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (300)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)));
RDebugUtils.currentLine=131117;
 //BA.debugLineNum = 131117;BA.debugLine="LblTitle.text=\"Rotating Clock - By VB-MUNDO\"";
mostCurrent._lbltitle.setText((Object)("Rotating Clock - By VB-MUNDO"));
RDebugUtils.currentLine=131119;
 //BA.debugLineNum = 131119;BA.debugLine="ivRotatKnob.SendToBack";
mostCurrent._ivrotatknob.SendToBack();
RDebugUtils.currentLine=131120;
 //BA.debugLineNum = 131120;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="End Sub";
return "";
}
public static String  _calcangle(float _x,float _y) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "calcangle"))
	return (String) Debug.delegate(mostCurrent.activityBA, "calcangle", new Object[] {_x,_y});
float _tiempo = 0f;
int _hora = 0;
int _resto = 0;
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub CalcAngle(X As Float, Y As Float)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="Dim Tiempo As Float, Hora As Int, Resto As Int";
_tiempo = 0f;
_hora = 0;
_resto = 0;
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="Angle = getAngle(X, Y)";
_angle = _getangle(_x,_y);
RDebugUtils.currentLine=262147;
 //BA.debugLineNum = 262147;BA.debugLine="Tiempo=Angle*2";
_tiempo = (float) (_angle*2);
RDebugUtils.currentLine=262151;
 //BA.debugLineNum = 262151;BA.debugLine="If Tiempo>-1 Then";
if (_tiempo>-1) { 
RDebugUtils.currentLine=262152;
 //BA.debugLineNum = 262152;BA.debugLine="Hora=Tiempo/60.09";
_hora = (int) (_tiempo/(double)60.09);
RDebugUtils.currentLine=262153;
 //BA.debugLineNum = 262153;BA.debugLine="Resto=Tiempo-(Hora*60.09)";
_resto = (int) (_tiempo-(_hora*60.09));
 }else {
RDebugUtils.currentLine=262155;
 //BA.debugLineNum = 262155;BA.debugLine="Hora=12-(Abs(Tiempo)/60.09)";
_hora = (int) (12-(anywheresoftware.b4a.keywords.Common.Abs(_tiempo)/(double)60.09));
RDebugUtils.currentLine=262156;
 //BA.debugLineNum = 262156;BA.debugLine="Resto=(360+Tiempo)-((Hora-6)*60.09)";
_resto = (int) ((360+_tiempo)-((_hora-6)*60.09));
 };
RDebugUtils.currentLine=262158;
 //BA.debugLineNum = 262158;BA.debugLine="If Resto>60 Then Resto=0";
if (_resto>60) { 
_resto = (int) (0);};
RDebugUtils.currentLine=262159;
 //BA.debugLineNum = 262159;BA.debugLine="LblHora.Text=NumberFormat(Hora,2,0)";
mostCurrent._lblhora.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat(_hora,(int) (2),(int) (0))));
RDebugUtils.currentLine=262160;
 //BA.debugLineNum = 262160;BA.debugLine="LblMinutos.Text=NumberFormat(Resto,2,0)";
mostCurrent._lblminutos.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat(_resto,(int) (2),(int) (0))));
RDebugUtils.currentLine=262161;
 //BA.debugLineNum = 262161;BA.debugLine="End Sub";
return "";
}
public static float  _getangle(float _x,float _y) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "getangle"))
	return (Float) Debug.delegate(mostCurrent.activityBA, "getangle", new Object[] {_x,_y});
float _dx = 0f;
float _dy = 0f;
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Private Sub getAngle(X As Float, Y As Float) As Fl";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="Dim dx, dy As Float";
_dx = 0f;
_dy = 0f;
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="dx = (ivRotatKnob.Width / 2) - X";
_dx = (float) ((mostCurrent._ivrotatknob.getWidth()/(double)2)-_x);
RDebugUtils.currentLine=196611;
 //BA.debugLineNum = 196611;BA.debugLine="dy = Y - (ivRotatKnob.Height / 2)";
_dy = (float) (_y-(mostCurrent._ivrotatknob.getHeight()/(double)2));
RDebugUtils.currentLine=196612;
 //BA.debugLineNum = 196612;BA.debugLine="Return ATan2(-dx, -dy) / cPI * 180";
if (true) return (float) (anywheresoftware.b4a.keywords.Common.ATan2(-_dx,-_dy)/(double)anywheresoftware.b4a.keywords.Common.cPI*180);
RDebugUtils.currentLine=196613;
 //BA.debugLineNum = 196613;BA.debugLine="End Sub";
return 0f;
}
public static boolean  _knob_touch(Object _viewtag,int _action,float _x,float _y,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "knob_touch"))
	return (Boolean) Debug.delegate(mostCurrent.activityBA, "knob_touch", new Object[] {_viewtag,_action,_x,_y,_motionevent});
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Knob_Touch(ViewTag As Object, Action As Int, X";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Select Action";
switch (_action) {
case 0: {
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="CalcAngle(X, Y)";
_calcangle(_x,_y);
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="ivRotatKnob.SetBackgroundImage(bp.Rotate(bmpPre";
mostCurrent._ivrotatknob.SetBackgroundImage(mostCurrent._bp.Rotate((android.graphics.Bitmap)(mostCurrent._bmppressed.getObject()),mostCurrent._bmppressed.getWidth(),mostCurrent._bmppressed.getHeight(),(int) (_angle),anywheresoftware.b4a.keywords.Common.True));
 break; }
case 1: {
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="ivRotatKnob.SetBackgroundImage(bp.Rotate(bmp, b";
mostCurrent._ivrotatknob.SetBackgroundImage(mostCurrent._bp.Rotate((android.graphics.Bitmap)(mostCurrent._bmp.getObject()),mostCurrent._bmp.getWidth(),mostCurrent._bmp.getHeight(),(int) (_angle),anywheresoftware.b4a.keywords.Common.True));
 break; }
case 2: {
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="CalcAngle(X, Y)";
_calcangle(_x,_y);
RDebugUtils.currentLine=327689;
 //BA.debugLineNum = 327689;BA.debugLine="ivRotatKnob.SetBackgroundImage(bp.Rotate(bmpPre";
mostCurrent._ivrotatknob.SetBackgroundImage(mostCurrent._bp.Rotate((android.graphics.Bitmap)(mostCurrent._bmppressed.getObject()),mostCurrent._bmppressed.getWidth(),mostCurrent._bmppressed.getHeight(),(int) (_angle),anywheresoftware.b4a.keywords.Common.True));
 break; }
}
;
RDebugUtils.currentLine=327691;
 //BA.debugLineNum = 327691;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
RDebugUtils.currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="End Sub";
return false;
}
}